=== cli_tools/CMakeLists.txt ===
if(LUA_FOUND)
  add_subdirectory("mympd-script")
endif()
