=== dist/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2022 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_subdirectory(libmpdclient)
add_subdirectory(mjson)
add_subdirectory(mongoose)
add_subdirectory(rax)
add_subdirectory(sds)
add_subdirectory(tinymt)
