=== debian/changelog ===
mympd (10.1.1-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Modernize d/rules.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 18 Nov 2022 12:22:50 -0800

mympd (10.1.1-1) unstable; urgency=medium

  * Release from master

 -- Juergen Mang <mail@jcgames.de>  Sun, 13 Nov 2022 12:11:15 +0100
